[BACK]Return to update_openbsd CVS log [TXT][DIR] Up to [local] / openbsd / update_openbsd

Diff for /openbsd/update_openbsd/update_openbsd between version 1.14 and 1.56

version 1.14, 2008/11/19 22:38:00 version 1.56, 2013/12/28 02:58:37
Line 1 
Line 1 
 #!/bin/sh  #!/bin/sh
 # $RedRiver: update_openbsd,v 1.13 2008/11/19 22:35:56 andrew Exp $  # $AFresh1: update_openbsd,v 1.55 2013/12/28 02:56:24 andrew Exp $
   #
   # Copyright (c) 2012 Andrew Fresh <andrew@afresh1.com>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   #
   
 installed_sets() {  installed_sets() {
     local misc=/usr/share/doc/README      local misc=/usr/share/doc/README
Line 23 
Line 38 
             echo -n " $_d"              echo -n " $_d"
         fi          fi
     done      done
   
       sendmail -d0.1 --badoption </dev/null 2>/dev/null | grep -q SASL
       if [ $? == 0 ]; then
           echo -n ' sendmail-smtp_auth'
       fi
 }  }
   
 sets_exist () {  kernel_file_version() {
       echo exit | config -e $1 | grep -A1 ^OpenBSD
       #what $1 | sed -ne 's/[[:blank:]]\{1,\}//p'
   }
   
   version_in() {
         local _proto=${FTP%%://*}          local _proto=${FTP%%://*}
           local _file
   
         if [ X"ftp" == X"${_proto}" ]; then          if [ X"ftp" == X"${_proto}" ]; then
             echo "ls base*.tgz" | ${FTP_CMD} ${FTP}/ | awk '{ print $9 }'              local _list=`echo "ls base*.tgz" | ${FTP_CMD} ${FTP}/`
               _file=`echo ${_list} | awk '/base[0-9][0-9].tgz/ { print $9 }'`
   
         elif [ X"http" == X"${_proto}" ]; then          elif [ X"http" == X"${_proto}" ]; then
             ${FTP_CMD} -V -o - ${FTP}/ | grep '"base[0-9][0-9].tgz' | sed -e 's/.*\(base..\.tgz\).*/\1/'              local _list=`${FTP_CMD} -V -o - ${FTP}/`
               _file=`echo ${_list} | awk '/[^x]base[0-9][0-9]*\.tgz/ {
                       sub("^.*base","base");
                       sub("\.tgz.*",".tgz");
                       print $0;
                   }'`
   
           elif [ X"scp" == X"${_proto}" ]; then
               echo SCP is not yet supported >&2
               return 2
   
         else          else
             echo Unsupported FTP ${FTP} >&2              echo Unsupported FTP ${FTP} >&2
             return 2              return 2
   
         fi          fi
   
           local _v=${_file##*base}
           _v=${_v%.tgz*}
           echo $_v
 }  }
   
 set_version() {  set_version() {
Line 72 
Line 115 
   
     fi      fi
   
     if [ X"" == X"${_v}" ]; then      if [ X"" != X"${MIRROR}" -a X"" == X"${_v}" ]; then
         if [ X"No" == X"${FORCE_DIR}" ]; then          if [ X"No" == X"${FORCE_DIR}" ]; then
             _dir=${NEW_VER}              _dir=${NEW_VER}
         else          else
Line 80 
Line 123 
         fi          fi
         FTP=${MIRROR}/${_dir}/`machine`          FTP=${MIRROR}/${_dir}/`machine`
   
         _file=`sets_exist`          _v=`version_in`
   
         if [ X"" == X"${_file}" ]; then          if [ X"" == X"${_v}" ]; then
             if [ X"No" != X"$FORCE_DIR" ]; then              if [ X"No" != X"$FORCE_DIR" ]; then
                 echo No sets in forced [${FTP}] >&2                  echo No sets in forced [${FTP}] >&2
                 return 2                  return 2
Line 92 
Line 135 
             _dir=${NEW_VER}              _dir=${NEW_VER}
             FTP=${MIRROR}/${_dir}/`machine`              FTP=${MIRROR}/${_dir}/`machine`
   
             _file=`sets_exist`              _v=`version_in`
             if [ X"" == X"${_file}" ]; then  
                 echo No sets in [${FTP}] >&2  
                 return 2  
             fi  
         fi          fi
   
         _v=${_file##*base}  
         _v=${_v%.tgz*}  
   
         if [ X"" == X"${_v}" ]; then          if [ X"" == X"${_v}" ]; then
             echo No version in file [$_file] >&2              echo No sets in [${FTP}] >&2
             return 2              return 2
         elif [ X"${_cv}" == X"${_v}" ]; then          elif [ X"${_cv}" == X"${_v}" ]; then
             NEW_VER=$CUR_VER              NEW_VER=$CUR_VER
Line 130 
Line 166 
     fi      fi
   
     FILE_VER=$_v      FILE_VER=$_v
     FTP=${MIRROR}/${_dir}/`machine`      if [ X"" != X"${MIRROR}" ]; then
           FTP=${MIRROR}/${_dir}/`machine`
       fi
   
       BOOT_KERNEL=`( \
           echo bsd; \
           [ -e /boot.conf ] && sed -E '/^ *(set +image|boot) +/!d ; \
               s///; s/^.*://; s/ .*$//' /boot.conf \
       ) | tail -1`
       BOOT_KERNEL=`follow_symlink /$BOOT_KERNEL`
       BOOT_KERNEL="/${BOOT_KERNEL#/}"
   
       BOOT_KERNEL_VERSION=`kernel_file_version $BOOT_KERNEL`
   
       BOOTED_KERNEL_VERSION=`sysctl -n kern.version`
       NEW_KERNEL_VERSION=""
   
       # We want to default to what we had
       INSTALL_KERNELS="${BOOT_KERNEL#/}"
       # if the boot kernel was our specially named bsd.sp, we install from bsd
       if [ X"$INSTALL_KERNELS" == X"bsd.sp" ]; then
           INSTALL_KERNELS="bsd"
       fi
       # with a second option of an mp kernel if is is a likely candidate
       if [ X"$INSTALL_KERNELS" != X"bsd.mp" ]; then
           local _ncpu=$(sysctl -n hw.ncpufound)
           [ $_ncpu -gt 1 ] && INSTALL_KERNELS="$INSTALL_KERNELS bsd.mp"
       fi
       # or just bsd otherwise
       if [ X"${INSTALL_KERNELS% *}" != X"bsd" ]; then
           INSTALL_KERNELS="$INSTALL_KERNELS bsd"
       fi
       BOOT_KERNELS=$INSTALL_KERNELS
       INSTALL_KERNELS="$INSTALL_KERNELS bsd.rd"
 }  }
   
 get_sets() {  get_sets() {
     echo '### GETTING SETS ###'      echo '==> GETTING SETS'
     if [ X"" == X"$FTP" ]; then      if [ X"" == X"$FTP" ]; then
         echo ERROR: No FTP site set! >&2          echo ERROR: No FTP site set! >&2
         return 1          return 1
Line 145 
Line 214 
   
     local _v=$FILE_VER      local _v=$FILE_VER
   
     for _b in `echo /bsd* bsd bsd.mp bsd.rd | sort -u`; do      for _b in $INSTALL_KERNELS; do
         if [ -e /${_b} -a ! -e ./${_b} ]; then          if [ ! -e ./${_b} ]; then
             echo $FTP_CMD ${FTP}/${_b}              echo "===> $FTP_CMD ${FTP}/${_b}"
             $FTP_CMD ${FTP}/${_b}              $FTP_CMD ${FTP}/${_b}
         fi          fi
     done      done
   
     for _s in $INSTALLED_SETS; do      for _s in $INSTALLED_SETS; do
         if [ ! -e ./${_s}${_v}.tgz ]; then          local _file=${_s}${_v}.tgz
             echo $FTP_CMD ${FTP}/${_s}${_v}.tgz          if [ ${_s} == sendmail-smtp_auth ]; then
             $FTP_CMD ${FTP}/${_s}${_v}.tgz              _file=${_s}.gz
         fi          fi
   
           if [ ! -e ./${_file} ]; then
               echo "===> $FTP_CMD ${FTP}/${_file}"
               $FTP_CMD ${FTP}/${_file}
           fi
     done      done
   
     if [ ! -e MD5 ]; then      local _type
         echo $FTP_CMD ${FTP}/MD5      local _ftp
         $FTP_CMD ${FTP}/MD5      for _type in $CHECKSUM_TYPES; do
           [ -e $_type ] && break
           _ftp=`echo "$FTP" | sed -e 's,://[^/]*/,://ftp.openbsd.org/,'`
           echo "===> $FTP_CMD ${_ftp}/$_type"
           $FTP_CMD ${_ftp}/$_type
       done
   }
   
   follow_symlink () {
       local _file=$1
       # This could go circular, but I dunno how to fix that.
       if [ -h $_file ]; then
           follow_symlink $( file $_file |
               grep 'symbolic link' |
               sed -e s/^.*\\\`// -e s/\\\'\$// )
       else
           echo $_file
     fi      fi
   }
   
     ls bsd* *.tgz | sed -e 's/\(.*\)/(\1)/' > index  check_sum () {
     grep -f index MD5 | md5 -c      local _type=$1
       echo "==> CHECKING $_type SUMS"
       cd $RELEASEDIR
   
       if [ ! -e $_type ]; then
           echo $_type File does not exist!
           return 1
       fi
   
       ls bsd* *gz | sed -e 's/\(.*\)/(\1)/' > index
       grep -f index $_type | sum -c
   
     if [ $? -ne 0 ]; then      if [ $? -ne 0 ]; then
         echo ERROR: MD5 does not match! >&2          echo ERROR: $_type does not match! >&2
         return 1          return 1
     fi      fi
 }  }
   
 install_kernel() {  check_sets() {
     echo '### INSTALLING KERNEL ###'      echo '==> CHECKING SETS'
     if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then      cd $RELEASEDIR
         echo ${0##*/} must be run as root or SUDO must be set! >&2  
         exit 1  
     fi  
   
     if [ X"" == X"$RELEASEDIR" ]; then      local _missing_sets
         echo ERROR: no source for new kernels! >&2      local _v=$FILE_VER
         exit 1  
     else      for _n in $INSTALL_KERNELS; do
         cd $RELEASEDIR          local _o=$_n
           [ X"bsd" == X"${_o}" -a -e /bsd.sp ] && _o=bsd.sp
           if [ -e /${_o} -a ! -e ./${_n} ]; then
               echo ${_o} does not exist
               _missing_sets=1
           fi
   
           if [ X"${BOOT_KERNEL}" == X"/${_o}" -a -e ./${_n} ]; then
               NEW_KERNEL_VERSION=`kernel_file_version ./${_n}`
           fi
       done
   
       if [ X"$NEW_KERNEL_VERSION" == X"" ]; then
           echo Missing replacement for boot kernel $BOOT_KERNEL >&2
           _missing_sets=1
     fi      fi
   
     if [ ! -e bsd ]; then      for _s in $INSTALLED_SETS; do
         echo ERROR: new bsd kernel does not exist! >&2          local _file=${_s}${_v}.tgz
         exit 1          if [ ${_s} == sendmail-smtp_auth ]; then
               _file=${_s}.gz
           fi
           if [ ! -e ./${_file} ]; then
               echo ${_file} does not exist
               _missing_sets=1
           fi
       done
   
       if [ X"" == X"${_missing_sets}" ]; then
           echo '===> All OK'
     fi      fi
   
     if [ -e /bsd.mp -a ! -e bsd.mp ]; then      local _type
         echo ERROR: new bsd.mp kernel does not exist! >&2      for _type in $CHECKSUM_TYPES; do
           if [ -e $_type ]; then
               check_sum $_type
               [ $? -ne 0 -a -z "$IGNORE_CHECKSUM_ERROR" ] && exit 1
           fi
       done
   }
   
   
   install_kernels() {
       echo '==> INSTALLING KERNEL'
       if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then
           echo ${0##*/} must be run as root or SUDO must be set! >&2
         exit 1          exit 1
     fi      fi
   
     if [ ! -e bsd.rd ]; then      if [ X"" == X"$RELEASEDIR" ]; then
         echo ERROR: new bsd.rd kernel does not exist! >&2          echo ERROR: no source for new kernels! >&2
         exit 1          exit 1
     fi      fi
   
     local _v=$FILE_VER      if [ X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
     if [ -e base${_v}.tgz ]; then          echo "===> Backing up $BOOT_KERNEL to /obsd"
         echo Extracting new firmware and ifconfig from base${_v}.tgz          $SUDO ln -f $BOOT_KERNEL /obsd
         $SUDO tar -C $DESTDIR -xzphf base${_v}.tgz \          if [ $? -ne 0 ]; then
                 ./etc/firmware ./sbin/ifconfig              echo "Error copying old kernel!" >&2
               exit 1
           fi
     fi      fi
   
     $SUDO rm -f /obsd      cd $RELEASEDIR
     $SUDO ln /bsd /obsd  
     if [ $? -ne 0 ]; then  
         echo "Error copying old kernel!"  
         exit 1  
     fi  
   
     for _b in bsd*; do      for _b in $INSTALL_KERNELS; do
         $SUDO rm -f /nbsd          $SUDO rm -f /nbsd
           local _bd=$_b
           [ X"${_b}" == X"bsd" ] && _bd="bsd.sp"
   
         if [ X"${_b}" == X"bsd" ]; then          local _is_boot=""
             echo Copying bsd to /bsd.sp          [ X"$BOOT_KERNEL" == X"/${_bd}" ] && _is_boot="# boot kernel"
             $SUDO cp bsd /nbsd && $SUDO mv /nbsd /bsd.sp  
             if [ $? -ne 0 ]; then          echo "===> Copying $_b to /$_bd $_is_boot"
                 echo ERROR: Could not copy new SP kernel! >&2          $SUDO cp ${_b} /nbsd && $SUDO mv /nbsd /${_bd}
                 exit 1          if [ $? -ne 0 ]; then
             fi              echo ERROR: Could not copy new $_bd kernel! >&2
         else              exit 1
             if [ -e /$_b ]; then  
                 echo Copying $_b to /  
                 $SUDO cp ${_b} /nbsd && $SUDO mv /nbsd /${_b}  
                 if [ $? -ne 0 ]; then  
                     echo ERROR: Could not copy new $_b kernel! >&2  
                     exit 1  
                 fi  
             fi  
         fi          fi
     done      done
   
       cd $OLDPWD
   
     if [ ! -h /bsd ]; then      if [ ! -h /bsd ]; then
         if [ -e /bsd.mp ]; then              cd /
             echo linking /bsd.mp to /bsd          for _b in $BOOT_KERNELS; do
             $SUDO ln -sf /bsd.mp /bsd              [ X"$_b" == X"bsd" ] && _b="bsd.sp"
         else              if [ -e $_b ]; then
             echo linking /bsd.sp to /bsd                  echo "===> symlinking $_b to /bsd"
             $SUDO ln -sf /bsd.sp /bsd                  $SUDO ln -sf $_b bsd
         fi                  if [ $? -ne 0 ]; then
         if [ $? -ne 0 ]; then                      echo ERROR: Could not symlink new kernel! >&2
             echo ERROR: Could not symlink new kernel! >&2                      exit 1
             exit 1                  fi
         fi                  break
               fi
           done
               cd $OLDPWD
     fi      fi
 }  }
   
 install_sets() {  install_sets() {
     echo '### INSTALLING SETS ###'      echo '==> INSTALLING SETS'
     if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then      if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then
         echo ${0##*/} must be run as root or SUDO must be set! >&2          echo ${0##*/} must be run as root or SUDO must be set! >&2
         exit 1          exit 1
Line 269 
Line 399 
   
     local _v=$FILE_VER      local _v=$FILE_VER
   
     for _f in *${_v}.tgz; do      local _sets=`ls *${_v}.tgz | grep -v ^base `
       for _f in ${_sets} base${_v}.tgz; do
         _path=$DESTDIR          _path=$DESTDIR
         if [ X"etc${_v}.tgz"  == X"$_f" \          if [ X"etc${_v}.tgz"  == X"$_f" \
             -o X"xetc${_v}.tgz" == X"$_f" ]; then              -o X"xetc${_v}.tgz" == X"$_f" ]; then
             if [ X"" != X"$SYSMERGE" ]; then              [ X"" != X"$SYSMERGE" ] && continue
                 continue  
             fi  
             _path=/var/tmp/temproot              _path=/var/tmp/temproot
         fi          fi
   
         echo Extracting $_f to $_path          echo "===> Extracting $_f to $_path"
         $SUDO mkdir -p $_path          $SUDO mkdir -p $_path
         $SUDO tar -C $_path -xzphf ${RELEASEDIR}/${_f}          $SUDO tar -C $_path -xzphf ${RELEASEDIR}/${_f}
         if [ $? -ne 0 ]; then          if [ $? -ne 0 ]; then
Line 288 
Line 417 
         fi          fi
     done      done
   
     echo Extracted all sets.      echo '===> Extracted all sets.'
 }  }
   
   install_sendmail_smtp_auth() {
       if [ -e ${RELEASEDIR}/sendmail-smtp_auth.gz ]; then
           gzcat ${RELEASEDIR}/sendmail-smtp_auth.gz > \
               ${RELEASEDIR}/sendmail-smtp_auth
       fi
       if [ -e ${RELEASEDIR}/sendmail-smtp_auth ]; then
           if ! pkg_info -qe 'cyrus-sasl-*'; then
               $SUDO pkg_add -i cyrus-sasl
           fi
   
           $SUDO install -o root -g smmsp -m 2555 \
               ${RELEASEDIR}/sendmail-smtp_auth \
               /usr/libexec/sendmail/sendmail
   
           echo '===> Installed sendmail with smtp_auth'
       fi
   }
   
 update_etc() {  update_etc() {
     echo '### UPDATING ETC ###'      echo '==> UPDATING ETC'
     if [ ! -e $SYSMERGE ]; then      if [ ! -e $SYSMERGE ]; then
         SYSMERGE=          echo "ERROR: Can't find sysmerge!" >&2
           exit 1;
     fi      fi
   
     if [ X"" == X"$SYSMERGE" ]; then      if [ X"" == X"$RELEASEDIR" ]; then
         if [ -e /var/tmp/temproot ]; then          echo "ERROR: no source for etc!" >&2
             MERGEMASTER=`which mergemaster`          exit 1
       fi
   
             if [ $? != 0 ]; then      cd $RELEASEDIR
                 $SUDO pkg_add -i mergemaster  
   
                 MERGEMASTER=`which mergemaster`      local _v=$FILE_VER
                 if [ $? != 0 ]; then      local _args=""
                     echo ERROR: mergemaster not installed! >&2      if [ -e etc${_v}.tgz ]; then
                     exit 1          _args="$_args -s etc${_v}.tgz"
                 fi      fi
             fi      if [ -e xetc${_v}.tgz ]; then
           _args="$_args -x xetc${_v}.tgz"
             echo '### RUNNING MERGEMASTER ###'      fi
             $SUDO $MERGEMASTER -irv      if [ X"" == X"$_args" ]; then
         else          echo ERROR: No upgrade sets found! >&2
             echo "ERROR: no source for etc!" >&2  
             exit 1  
         fi  
     else      else
         if [ X"" == X"$RELEASEDIR" ]; then          echo '==> RUNNING SYSMERGE'
             echo "ERROR: no source for etc!" >&2          $SUDO $SYSMERGE $_args
             exit 1  
         else  
             cd $RELEASEDIR  
         fi  
   
         local _v=$FILE_VER  
         if [ -e etc${_v}.tgz ]; then  
             _args="$_args -s etc${_v}.tgz"  
         fi  
         if [ -e xetc${_v}.tgz ]; then  
             _args="$_args -x xetc${_v}.tgz"  
         fi  
         if [ X"" == X"$_args" ]; then  
             echo ERROR: No upgrade sets found! >&2  
         else  
             echo '### RUNNING SYSMERGE ###'  
             _args="-a $_args"  
             $SUDO $SYSMERGE $_args  
         fi  
     fi      fi
   
       cd $OLDPWD
 }  }
   
   
 if [ -e /etc/update_openbsd.conf ]; then  if [ -e /etc/update_openbsd.conf ]; then
     . /etc/update_openbsd.conf      . /etc/update_openbsd.conf
 fi  fi
Line 350 
Line 479 
     . ${HOME}/.update_openbsdrc      . ${HOME}/.update_openbsdrc
 fi  fi
   
 MIRROR=${MIRROR:=ftp://ftp.openbsd.org/pub/OpenBSD}  #MIRROR=${MIRROR:=ftp://ftp.openbsd.org/pub/OpenBSD}
 FTP_CMD=${FTP_CMD:=ftp -V}  FTP_CMD=${FTP_CMD:=ftp -V}
 PKG_PATH=${PKG_PATH:=/usr/ports/packages/`machine`/all/:${MIRROR}/`uname -r`/packages/`machine`/}  PKG_PATH=${PKG_PATH:=/usr/ports/packages/`machine`/all/:${MIRROR}/`uname -r`/packages/`machine`/}
   
Line 360 
Line 489 
   
 INSTALLED_SETS=${INSTALLED_SETS:=`installed_sets`}  INSTALLED_SETS=${INSTALLED_SETS:=`installed_sets`}
   
   CHECKSUM_TYPES=${CHECKSUM_TYPES:=SHA256 MD5}
   
 set_version  set_version
 local _error=$?  local _error=$?
   
Line 367 
Line 498 
 echo "-= update_openbsd - helper script to update OpenBSD =-"  echo "-= update_openbsd - helper script to update OpenBSD =-"
 echo "------------------------------------------------------"  echo "------------------------------------------------------"
 echo  echo
 echo "          SUDO: $SUDO"  echo "           SUDO: $SUDO"
 echo "      SYSMERGE: $SYSMERGE"  echo "       SYSMERGE: $SYSMERGE"
 echo "        MIRROR: $MIRROR"  echo "         MIRROR: $MIRROR"
 echo "    RELEASEDIR: $RELEASEDIR"  echo "     RELEASEDIR: $RELEASEDIR"
 echo "       DESTDIR: $DESTDIR"  echo "        DESTDIR: $DESTDIR"
 echo "INSTALLED_SETS: $INSTALLED_SETS"  echo "    BOOT_KERNEL: $BOOT_KERNEL"
   echo "INSTALL_KERNELS: $INSTALL_KERNELS"
   echo " INSTALLED_SETS: $INSTALLED_SETS"
 echo  echo
 echo "       CUR_VER: $CUR_VER"  echo "        CUR_VER: $CUR_VER"
 echo "       NEW_VER: $NEW_VER"  echo "        NEW_VER: $NEW_VER"
 #echo "      FILE_VER: $FILE_VER"  #echo "       FILE_VER: $FILE_VER"
 echo  echo
   
 if [ ${_error} -ne 0 ]; then  if [ ${_error} -ne 0 ]; then
         exit ${_error}          exit ${_error}
 fi  fi
   
 get_sets  if [ X"" != X"${FTP}" ]; then
       get_sets
   fi
   
 if [ X"" != X"$SUDO" ]; then  check_sets || exit
     echo Please enter your sudo password if prompted.  
     echo You may be asked for it again later in the process.  echo "===> Last booted:\n$BOOTED_KERNEL_VERSION"
     $SUDO -v  if [ X"$BOOT_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \
     -a X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
       echo "Next boot (unless replaced):\n$BOOT_KERNEL_VERSION"
 fi  fi
   if [ -n "$NEW_KERNEL_VERSION" ]; then
       echo "===> New $BOOT_KERNEL:\n$NEW_KERNEL_VERSION";
   else
       echo "\n!!! WARNING: Will not replace boot kernel $BOOT_KERNEL! !!!\n" >&2
       echo "ctrl+C to cancel, enter to continue anyway" >&2
       local _temp
       read _temp
       NEW_KERNEL_VERSION=$BOOT_KERNEL_VERSION
   fi
   
 install_kernel  if [ -n "$SUDO" -a $CUR_VER != $NEW_VER ]; then
       echo >&2
       echo "!!! You are upgrading between OpenBSD versions.     !!!" >&2
       echo "!!! You should make sure you have a root shell open !!!" >&2
       echo "!!! It is needed in order to run /sbin/oreboot.     !!!" >&2
       echo "!!! sudo MAY NOT WORK after sets are extracted.     !!!" >&2
       echo >&2
       echo "ctrl+C to cancel, enter to continue" >&2
       local _temp
       read _temp
   fi
   
 if [ $CUR_VER == $NEW_VER ]; then  if [ -n "$SUDO" ]; then
     install_sets      echo
       echo You may be asked for your sudo password multiple times.
       $SUDO -v -p "sudo Password: "
   fi
   
   if [ X"$NEW_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \
        -a ! -e /sbin/oreboot ]; then
       $SUDO cp /sbin/reboot /sbin/oreboot
       if [ $? -ne 0 ]; then
           echo "Error copying old reboot command!" >&2
           exit 1
       fi
       echo "/sbin/reboot copied to /sbin/oreboot"
   fi
   
   install_kernels
   install_sets
   
   if [ X"$NEW_KERNEL_VERSION" == X"$BOOTED_KERNEL_VERSION" ]; then
       install_sendmail_smtp_auth
   
       if [ -e /sbin/oreboot ]; then
           echo Removing /sbin/oreboot
           $SUDO rm -f /sbin/oreboot
       fi
     update_etc      update_etc
   
     echo '### UPDATING PACKAGES ###'      echo '==> UPDATING PACKAGES'
     $SUDO pkg_add -ui -F update -F updatedepends      $SUDO pkg_add -ui -F update -F updatedepends
   
 else  else
     echo Instructions for updating to the new version available from      echo Instructions for updating to the new version available from
     echo "  http://www.openbsd.org/faq/upgrade${_v}.html"      if [ X"snapshots" == X"$FORCE_DIR" ]; then
           echo "  http://www.openbsd.org/faq/current.html"
       else
           echo "  http://www.openbsd.org/faq/upgrade${FILE_VER}.html"
       fi
 fi  fi
   
 echo New kernel installed.  Please reboot!  echo New kernel installed.  Please reboot!
   if [ -e /sbin/oreboot ]; then
       echo Possibly using /sbin/oreboot
   fi

Legend:
Removed from v.1.14  
changed lines
  Added in v.1.56

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>